#ifndef PREC_S_H
#define PREC_S_H

#ifdef PREC_S

#define FPADDCOUNT 1
#define FPMULCOUNT 1
#define FPMADCOUNT 2

// TYPE
#define CUBLAS_TYPE float
#define CUBLAS_BASETYPE CUBLAS_TYPE
#define CUBLAS_ZERO 0.
#define CUBLAS_ONE 1.
#define CUBLAS_NEGONE -1.
#define CBLAS_TYPE float
#define CBLAS_BASETYPE CBLAS_TYPE
#define CBLAS_ZERO 0.
#define CBLAS_ONE 1.
#define CBLAS_NEGONE -1.
#define MBLAS_TYPE qd_real
#define MBLAS_BASETYPE MBLAS_TYPE
#define MBLAS_ZERO qd_real(0.)
#define MBLAS_ONE qd_real(1.)
#define MBLAS_NEGONE qd_real(-1.)

#if defined (MUBLAS)
#define GPU_TYPE float
#elif defined (CUBLAS)
#define GPU_TYPE float
#elif defined (KBLAS)
#define GPU_TYPE float
#elif defined (MAGMA)
#define GPU_TYPE float
#elif defined (CULA)
#define GPU_TYPE float
#elif defined (ASPEN)
#define GPU_TYPE float
#endif
#define MAKE_GPU_TYPE(x) (x)
#define MAKE_GPU_TYPE_REAL(r) (r)

// COPY
#define CBLAS_COPY cblas_scopy
#define MBLAS_COPY Rcopy
#define MUBLAS_COPY mublasScopy
#define CUBLAS_COPY cublasScopy
#define MAGMA_COPY magmablas_scopy
#define CULA_COPY culaDeviceScopy
#define KBLAS_COPY kblas_scopy

// SCAL
#define CBLAS_SCAL cblas_sscal
#define MBLAS_SCAL Rscal
#define MUBLAS_SCAL mublasSscal
#define CUBLAS_SCAL cublasSscal
#define MAGMA_SCAL 
#define CULA_SCAL
#define KBLAS_SCAL

// AXPY
#define CBLAS_AXPY cblas_saxpy
#define MBLAS_AXPY Raxpy
#define MUBLAS_AXPY mublasSaxpy
#define CUBLAS_AXPY cublasSaxpy
#define MAGMA_AXPY magmablas_saxpy
#define CULA_AXPY culaDeviceSaxpy
#define KBLAS_AXPY kblas_saxpy

// DOT
#define CBLAS_DOT cblas_sdot
#define MBLAS_DOT Rdot
#define MUBLAS_DOT mublasSdot
#define CUBLAS_DOT cublasSdot
#define MAGMA_DOT magmablas_sdot
#define CULA_DOT culaDeviceSdot
#define KBLAS_DOT kblas_sdot

// GEMV
#define MUBLAS_GEMV_MGPU_ASYNC mublasSgemvMgpuAsync
#define MUBLAS_GEMV_MGPU mublasSgemvMgpu
#define CBLAS_GEMV cblas_sgemv
#define MBLAS_GEMV Rgemv
#define MUBLAS_GEMV mublasSgemv
#define CUBLAS_GEMV cublasSgemv
#define MAGMA_GEMV magmablas_sgemv
#define CULA_GEMV culaDeviceSgemv
#define KBLAS_GEMV kblas_sgemv
#define ASPEN_GEMV ASPEN_sgemv

// SYMV
#define CBLAS_SYMV cblas_ssymv
#define MBLAS_SYMV Rsymv
#define MUBLAS_SYMV mublasSsymv
#define CUBLAS_SYMV cublasSsymv
#define MAGMA_SYMV magmablas_ssymv
#define CULA_SYMV culaDeviceSsymv
#define KBLAS_SYMV kblas_ssymv
#define ASPEN_SYMV ASPEN_ssymv

// TRMV
#define CBLAS_TRMV cblas_strmv
#define MBLAS_TRMV Rtrmv
#define MUBLAS_TRMV mublasStrmv
#define CUBLAS_TRMV cublasStrmv
#define MAGMA_TRMV magmablas_strmv
#define CULA_TRMV culaDeviceStrmv
#define KBLAS_TRMV
#define ASPEN_TRMV

// TRSV
#define CBLAS_TRSV cblas_strsv
#define MBLAS_TRSV Rtrsv
#define MUBLAS_TRSV mublasStrsv
#define CUBLAS_TRSV cublasStrsv
#define MAGMA_TRSV magmablas_strsv
#define CULA_TRSV culaDeviceStrsv
#define KBLAS_TRSV
#define ASPEN_TRSV

// GEMM
#define BLASX_GEMM blasx_sgemm
#define CBLAS_GEMM cblas_sgemm
#define MBLAS_GEMM Rgemm
#define MUBLAS_GEMM mublasSgemm
#define CUBLAS_GEMM cublasSgemm
#define CUBLAS_GEMM_MGPU cublasXtSgemm
#define MAGMA_GEMM magmablas_sgemm
#define CULA_GEMM culaDeviceSgemm
#define KBLAS_GEMM 
#define ASPEN_GEMM 

// GEMMIA
#define MUBLAS_GEMMIA mublasSgemmIA

// NRM2
#define CUBLAS_NRM cublasSnrm2
#define CBLAS_NRM cblas_snrm2
#define MBLAS_NRM Rnrm2

// GER
#define CBLAS_GER cblas_sger
#define MBLAS_GER Rger
#define MUBLAS_GER 
#define CUBLAS_GER cublasSger
#define MAGMA_GER magmablas_sger
#define CULA_GER culaDeviceSger
#define KBLAS_GER 
#define ASPEN_GER 

// CSRMV
#define MUBLAS_CSRMV mublasScsrmv
#define CUBLAS_CSRMV cusparseScsrmv

// HYBMV
#define CUBLAS_HYBMV cusparseShybmv
#define SPARSE_FORMAT_CONVERT_FROM_SCR cusparseScsr2hyb

// GEAM
#define MUBLAS_GEAM mublasSgeam
#define CUBLAS_GEAM cublasSgeam

#endif
#endif
