#ifndef TESTING_LEVEL3IA
#define TESTING_LEVEL3IA

// === GEMMIA =====================================================
#if defined (GEMMIA)
#define DIM3
// target routine
#if defined (MUBLAS)
#define ROUTINE_TARGET(ha,th,m,n,k,al,A,lda,B,ldb,bt,C,Cu,Cl,ldc) MUBLAS_GEMMIA(&ha,th.tranA,th.tranB,m,n,k,&al,A,lda,B,ldb,&bt,C,Cu,Cl,ldc)
#endif
// reference routine
#if defined (CHECK_MPACK)
#define ROUTINE_REFERENCE(ha,th,m,n,k,al,A,lda,B,ldb,bt,C,ldc) MBLAS_GEMM(th.tranA,th.tranB,m,n,k,&al,A,lda,B,ldb,&bt,C,ldc)
#elif defined (CHECK_CBLAS)
#if defined (PREC_S) || defined (PREC_D) || defined (PREC_W) || defined (PREC_B)
#define ROUTINE_REFERENCE(ha,th,m,n,k,al,A,lda,B,ldb,bt,C,ldc) CBLAS_GEMM(CblasColMajor,cblas_trans_const_m(th.tranA),cblas_trans_const_m(th.tranB),m,n,k,al,A,lda,B,ldb,bt,C,ldc)
#else
#define ROUTINE_REFERENCE(ha,th,m,n,k,al,A,lda,B,ldb,bt,C,ldc) CBLAS_GEMM(CblasColMajor,cblas_trans_const_m(th.tranA),cblas_trans_const_m(th.tranB),m,n,k,&al,A,lda,B,ldb,&bt,C,ldc)
#endif
#elif defined (CHECK_CUBLAS)
#define ROUTINE_REFERENCE(ha,th,m,n,k,al,A,lda,B,ldb,bt,C,ldc) CUBLAS_GEMM(ha,cublas_trans_const_m(th.tranA),cublas_trans_const_m(th.tranB),m,n,k,&al,A,lda,B,ldb,&bt,C,ldc)
#endif
// %%%
#define ROUTINE_FLOPS(m,n,k)			(FPMADCOUNT*m*n*k+(2*FPMULCOUNT+FPADDCOUNT)*m*n)
#define ROUTINE_BYTES(m,n,k,s)			((m*k+k*n+2*m*n)*s) 
#define ROUTINE_MAXSIZE(gmem,margin,s)	(sqrt((gmem-margin)/s/3)) 
#define ROUTINE_MAXSIZE_1(gmem,margin,s,dim1)		((gmem-margin)/s/dim1) // !!!!!!!!!!!!!!
#define ROUTINE_MAXSIZE_2(gmem,margin,s,dim1,dim2)	((gmem+margin+s+dim1+dim2)*0)  // !!!!!!!!!!!!!!!
#endif
// ==============================================================


#endif
